package fta3;

import java.io.*;
import java.lang.Integer;
import java.util.*;

class ETree implements Serializable {

    public String tProjectNm;
    public String tFileNm;
    public TEvent[] tEvents;
    public TGate[] tGates;
    public TEdge[] tEdges;
    public TTranx[] tIn;
    public TTranx[] tOut;

    ETree () {
        tProjectNm = "";
        tFileNm = "";
        tEvents = new TEvent[0];
        tGates = new TGate[0];
        tEdges = new TEdge[0];
        tIn = new TTranx[0];
        tOut = new TTranx[0];
    }
    ETree (String p, String x) {
        tProjectNm = p;
        tFileNm = x;
        tEvents = new TEvent[0];
        tGates = new TGate[0];
        tEdges = new TEdge[0];
        tIn = new TTranx[0];
        tOut = new TTranx[0];
    }
    ETree (String y, String x, TEvent[] ns, TGate[] gs, 
	    TEdge[] es, TTranx[] is, TTranx[] os) 
    {   tProjectNm = y;
        tFileNm = x;
	tEvents = ns;
        tGates = gs;
        tEdges = es;
        tIn = is;
        tOut = os;
    }

    public TNode[] tNodes () {
        int a = tEvents.length;
        int b = tIn.length;
        int c = tOut.length;
        int w = a + b + c;
	TNode[] ls = new TNode[w];
        for (int i = 0; i < a; i++) {
            ls[i] = tEvents[i];
	}
        for (int i = 0; i < b; i++) {
            ls[a+i] = tIn[i];
	}
        for (int i = 0; i < c; i++) {
            ls[a+b+i] = tOut[i];
	}
        return ls;   
    }

    public static ETree ordET (ETree t) {
        int m = t.tEdges.length;
        int n = t.tEvents.length;
        boolean flag = false;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (t.tEvents[i].nId.equals (t.tEdges[j].eSource)) {
                    flag = false;
		    break;
		}
		else {
		    flag = true;
                    continue;
		} 
	    }
            if (flag = false) continue; 
            else {
                t.tEvents[i].nDes = "TOP";
                return t;
	    }
	}
        return null;
    }

    public static ETree fillET (ETree t) {
        int k = t.tEdges.length;
        for (int i = 0; i < k; i++) {
            t.tEdges[i] = fillNode (t.tEdges[i], t.tNodes ());
	}
        return t;
    }

    public static TEdge fillNode (TEdge e, TNode[] vs) {
        int k = vs.length;
        for (int i = 0; i < k; i++) {
            if (e.eSource.nId.equals (vs[i].nId)) 
                                { e.eSource = vs[i]; break; }
            else continue;
	}
        for (int i = 0; i < k; i++) {
            if (e.eDest.nId.equals (vs[i].nId)) 
                                { e.eDest = vs[i]; break; }
            else continue;
	}
        return e;
    }

    public static ETree linkETs (ETree[] ts) {
        int x = ts.length;
        for (int i = 0; i < x; i++) {
	    if (ts[i].tProjectNm == ".dummy") continue; // i cycle
            else for (int j = 0; j < x; j++) {
		if (ts[j].tProjectNm == ".dummy") continue; // j cycle
                     else if (0 < ts[j].tIn.length) 
                          for (int h = 0; h < ts[i].tOut.length; h++) { 
                              if (matchTranx (ts[i], ts[j], h)) {
				  ts[i] = mergeET (ts[i], ts[j], h);
                                  ts[j] = new ETree (".dummy", "");
                                  break;
			      }
                              else continue; // h cycle
			  }
                          else if (0 < ts[i].tIn.length) 
                               for (int h = 0; h < ts[j].tOut.length; h++) { 
                                   if (matchTranx (ts[j], ts[i], h)) {
		     		      ts[i] = mergeET (ts[j], ts[i], h);
                                      ts[j] = new ETree (".dummy", "");
                                      break;
				   }
                                   else continue; // h cycle
			       }
			  else continue; // j cycle
	    }
	}           
	for (int i = 0; i < x; i++) {
	    if (ts[i].tProjectNm == ".dummy") continue; 
            else return ts[i];
	}
        return null;
    }

    public static boolean matchTranx (ETree a, ETree b, int h) {
	return (a.tOut[h].nIName.equals (b.tFileNm));
    }

    public static ETree mergeET (ETree a, ETree b, int h) {
        String x = a.tOut[h].nIName;
        String y = b.tFileNm;
        String x1 = a.tOut[h].nId;
        String y1 = b.tIn[0].nId;
        TEdge[] as = a.tEdges;
        TEdge[] bs = b.tEdges;
        Integer ak = new Integer (0);
        Integer bk = new Integer (0);
        if (x.equals (y)) {
	    for (int i = 0; i < as.length; i++) {
		if (x1.equals (as[i].eSource.nId)) {
		    ak = new Integer (i);
                    break;
		}
                else continue;
	    };
	    for (int i = 0; i < bs.length; i++) {
		if (y1.equals (bs[i].eDest.nId)) {
		    bk = new Integer (i);
                    break;
		}
                else continue;
	    };
            int s1 = ak.intValue ();
            int s2 = bk.intValue ();
            String ih = bs[s2].nId + "_" + as[s1].nId;
            TEdge ne = new TEdge 
                       ("generated", ih, bs[s2].eSource, as[s1].eDest);
            a.tGates = TGate.joinElems (a.tGates, b.tGates);
            a.tEvents = TEvent.joinElems (a.tEvents, b.tEvents);
            a.tIn = new TTranx[0];
            a.tOut = TTranx.rmElem (a.tOut, h);
            a.tOut = TTranx.joinElems (a.tOut, b.tOut);
            a.tEdges = TEdge.rmElem (a.tEdges, s1);
            b.tEdges = TEdge.rmElem (b.tEdges, s2);
            a.tEdges = TEdge.joinElems (a.tEdges, b.tEdges);
            a.tEdges = TEdge.addElem (a.tEdges, ne);
            a.tFileNm = "generated";
            return a;
	}
	else return a;
    }

   public static ETree addEventLn (ETree t, String ln) { 
       TEvent ev = extEvent (ln, t.tFileNm);
       t.tEvents = TEvent.addElem (t.tEvents, ev);
       return t;
    }

    public static ETree addGateLn (ETree t, String ln) { 
        TGate gt = extGate (ln, t.tFileNm);
        t.tGates = TGate.addElem (t.tGates, gt);
        return t;
    }

    public static ETree addEdgeLn (ETree t, String ln) { 
        TEdge ne = extEdge (ln, t.tFileNm);
        t.tEdges = TEdge.addElem (t.tEdges, ne);
        return t;
    }

    public static ETree addInLn (ETree t, String ln) { 
        TTranx gt = extTrans (ln, "IN", t.tFileNm);
        t.tIn = TTranx.addElem (t.tIn, gt);
        return t;
    }

    public static ETree addOutLn (ETree t, String ln) { 
        TTranx gt = extTrans (ln, "OUT", t.tFileNm);
        t.tOut = TTranx.addElem (t.tOut, gt);
        return t;
    }

    public static TEvent extEvent (String ln, String f) { 
	String s1 = extSubString (ln, "eventtype: ", ' ');
	String s2 = extFSubString (ln, "idt: ", ' ', f);
	String s3 = extSubString (ln, "nme: '", '\''); 
        String s4 = extSubString (ln, "nam: '", '\''); 
	String s5 = extSubString (ln, "formular: '", '\''); 
        TEvent ev = new TEvent (f, s1, s2, s3, s4, s5);
        return ev;
    }

    public static TGate extGate (String ln, String f) { 
	String s1 = extSubString (ln, "gatetype: ", ' ');
	String s2 = extFSubString (ln, "idt: ", ' ', f);
	String s3 = extSubString (ln, "nme: '", '\''); 
	String s4 = extSubString (ln, "nam: '", '\''); 
        TGate gt = new TGate (f, s1, s2, s3, s4);
        return gt;
    }

    public static TTranx extTrans (String ln, String x, String f) { 
	String s1 = extFSubString (ln, "idt: ", ' ', f);
	String s2 = extSubString (ln, "nme: '", '\''); 
	String s3 = extSubString (ln, "nam: '", '\''); 
        TTranx gt = new TTranx (f, x, s1, s2, s3);
        return gt;
    }

    public static TEdge extEdge (String ln, String f) { 
        String s1 = extSubString (ln, "idt: ", ' ');
        String s2 = extFSubString (ln, "sou: ", ' ', f);
        String s3 = extFSubString (ln, "des: ", ' ', f); 
        TEdge ne = new TEdge (f, s1, s2, s3);
        return ne;
    }

    public static String extSubString (String ln, String x, char c) {
        int lx = x.length ();
        int n1 = ln.indexOf (x);
	int n2 = n1 + lx;
        int n3 = ln.indexOf (new Character(c).hashCode(), n2); 
        String nid = ln.substring (n2, n3);
        return nid;
    }

    public static String extFSubString 
                          (String ln, String x, char c, String f) {
	String y = extSubString (ln, x, c);
        String nid = f + ":" + y;
        return nid;
    }

    public static void printET (ETree ft) {
	  TEvent[] evs = ft.tEvents;
	  TGate[] gts = ft.tGates;
	  TEdge[] eds = ft.tEdges;
	  TTranx[] tis = ft.tIn;
          TTranx[] tos = ft.tOut;
	  int n1 = evs.length;
	  int n2 = gts.length;
	  int n3 = eds.length;
	  int n4 = tis.length;
          int n5 = tos.length;
          for (int x = 0; x < n1; x++) { TNode.printNode (evs[x]); }
          for (int x = 0; x < n2; ++x) { TNode.printNode (gts[x]); }
          for (int x = 0; x < n3; ++x) { TEdge.printEdge (eds[x]); }
          for (int x = 0; x < n4; ++x) { TNode.printNode (tis[x]); }
          for (int x = 0; x < n5; x++) { TNode.printNode (tos[x]); }
    }
}

class TEvent extends TNode implements Serializable {

    TEvent () { nSort = "EVENT"; };
    TEvent  
     (String f, String n1, String n2, String n3, String n4, String n5) {
        nFile = f;
	nSort = "EVENT";
        nType = n1;
        nId = n2;
        nIName = n3;
        nName = n4;
        nDes = n5;
    };

    public static TEvent[] addElem (TEvent[] xs, TEvent x) {
        int n = xs.length;
        TEvent[] ys = new TEvent[n+1];
        for (int i = 0; i < n; i++) {
	    ys[i] = xs[i];
	}
        ys[n] = x;
        return ys;
    }

    public static TEvent[] joinElems (TEvent[] as, TEvent[] bs) {
        int na = as.length;
        int nb = bs.length;
        int n = na + nb;
        TEvent[] ys = new TEvent[n];
        for (int i = 0; i < n; i++) {
	    if (i < na) ys[i] = as[i];
            else ys[i] = bs[i-na];
	};
        return ys;
    }
}

class TTranx extends TNode implements Serializable {

    TTranx () { nSort = "TRANSFER"; };
    TTranx  (String f, String n1, String n2, String n3, String n4)  {
	nFile = f;
        nSort = "TRANSFER";
        nType = n1;
        nId = n2; 
        nIName = n3;
        nName = n4;
    };

    public static TTranx[] addElem (TTranx[] xs, TTranx x) {
        int n = xs.length;
        TTranx[] ys = new TTranx[n+1];
        for (int i = 0; i < n; i++) {
	    ys[i] = xs[i];
	}
        ys[n] = x;
        return ys;
    }

    public static TTranx[] rmElem (TTranx[] xs, int k) {
        TTranx[] ys; 
        int n = xs.length;
        if (n < 1) return xs; 
        else {
	    int m = n - 1;
            ys = new TTranx[m];
            for (int i = 0; i < m; i++) {
              if (i < k) ys[i] = xs[i];
              else ys[i] = xs[i+1];
	    }
        }
        return ys;
    }

    public static TTranx[] joinElems (TTranx[] as, TTranx[] bs) {
        int na = as.length;
        int nb = bs.length;
        int n = na + nb;
        TTranx[] ys = new TTranx[n];
        for (int i = 0; i < n; i++) {
	    if (i < na) ys[i] = as[i];
            else ys[i] = bs[i-na];
	};
        return ys;
    }
}






