package fta3;

import java.util.HashSet;
import java.io.*;
import java.lang.reflect.Array;

class LgExp implements Serializable
{
    public LgSym eSym;
    public LgExp[] eSubs;
    public String eDes;
    public boolean eChk;
    public static final LgExp[] dummy = new LgExp[0];

    LgExp () {};
    LgExp (String var) {
        eSym = new LgSym (var);
        eSubs = new LgExp [0];
        eDes = "VAR";
        eChk = true; 
    };
    LgExp (LgSym p, LgExp[] as) {
        eSym = p; 
        eSubs = as; 
        eDes = setDes ();
        eChk = LgTyp.tLogic.equals (getType (p, as)); 
    };
    LgExp (LgSym p, LgExp x) {
        eSym = p; 
        LgExp[] as = {x};
        eSubs = as; 
        eDes = setDes ();
        eChk = LgTyp.tLogic.equals (getType (p, as)); 
    };
    LgExp (LgSym p, LgExp x1, LgExp x2) {
        eSym = p; 
        LgExp[] as = {x1,x2};
        eSubs = as; 
        eDes = setDes ();
        eChk = LgTyp.tLogic.equals (getType (p, as)); 
    };
    LgExp (LgSym p, LgExp x1, LgExp x2, LgExp x3) {
        eSym = p; 
        LgExp[] as = {x1,x2,x3};
        eSubs = as; 
        eDes = setDes ();
        eChk = LgTyp.tLogic.equals (getType (p, as)); 
    };

    public String setDes () { 
        if (this.eSubs.length < 1) return "CONS"; else return "FORM"; };

    public static LgTyp getType (LgSym p, LgExp[] as) {
        LgTyp[] xs = LgTyp.getFunForm (p.typeS);
        if (xs.length != as.length + 1) 
	    { return LgTyp.tError; }
	else { for (int i=0; i < as.length; ++i)
		{ if (!(xs[i+1].equals (LgTyp.tError)) 
                      && xs[i+1].equals 
		      (getType (as[i].eSym, as[i].eSubs))) continue;
                   else return LgTyp.tError; };
        LgTyp[] ys = new LgTyp [xs.length - as.length]; 
	ys[0] = xs[0];
	for (int i = 0; i < ys.length - 1; ++i) ys[i +1] = 
                                    xs[i + 1 + as.length];
	return LgTyp.buildFunType (ys);}
    };

    public static void printType (LgTyp t) {
	if (t.tArgs.length < 1) 
	    { System.out.print (" ");
	      System.out.print (t.tCon.nameT); }
        else {
	     System.out.print (" (");
             System.out.print (t.tCon.nameT);
             for (int i = 0; i < t.tArgs.length; ++i)
		 { printType (t.tArgs[i]); };
             System.out.print (")");
	}
    };

    public static void printExp (LgExp e) {
	if (e.eSubs.length < 1) 
	    { System.out.print ("[");
	      System.out.print (e.eSym.nameS);
              System.out.print (" :: " + e.eDes + "]");
	    }
        else {
	     System.out.print ("(");
             System.out.print (e.eSym.nameS + 
                           Integer.toString (e.eSym.arityS));
             for (int i = 0; i < e.eSubs.length; ++i)
		 { System.out.print (" "); 
                   printExp  (e.eSubs[i]); };
             System.out.print (")");
	}
    }

    public static void printExps (LgExp[] es) {
        int n = es.length;
        for (int i = 0; i < n; i++) {
            SimpleIO.promptln ("");
            printExp (es[i]);
            SimpleIO.promptln("");
	}
    }

    static public LgExp gtNC (LgSym z, LgExp[] vs, LgExp v) {
        LgExp x = new LgExp (z, vs);
        LgExp y = new LgExp (LgSym.imply,v,x);
        return y;
    }
}


