package fta3;

import java.util.HashSet;
import java.io.*;
import java.lang.reflect.Array;

//import fta.*;

public class LgTyp implements Serializable
{
    public LgTCon tCon;
    public LgTyp tArgs[]; 
    public boolean tChk;
    public static final LgTyp tLogic = new LgTyp ("logic");
    public static final LgTyp tError = new LgTyp ("error");

    LgTyp () {};
    LgTyp (String c) {
        tCon = new LgTCon (c);
        tArgs = new LgTyp [0];  
        tChk = c != "error"; 
    };
    LgTyp (String c, LgTyp as[]) {
        tCon = new LgTCon (c, as.length);
        tArgs = as;
        tChk = tchk (as);
    };
    LgTyp (String c, int n) {
        tCon = new LgTCon (c, n);
        tArgs = buildTypArray(c,n);
        tChk =  c != "error"; 
    };
    LgTyp (LgTCon a, LgTyp as[]) {
        tCon = a;
        tArgs = as;
	tChk = (a.kindT.arityK == as.length)
	    && (a.nameT != "error")
	    && tchk (as);
    };

    public static boolean tchk (LgTyp[] as) { 
        for (int i = 0; i < as.length; ++i) 
	    { if (as[i].tChk == false) return false; else continue; };
	return true; 
    };
    public static LgTyp[] buildTypArray (String c, int n) {
        LgTyp tas[] = new LgTyp [n];
	for (int i=0; i < n; ++i)
	    {tas[i] = new LgTyp(c);};
        return tas;
    };
    public static LgTyp[] getFunForm (LgTyp t) {
        LgTyp[] tv = getFunFormAux (t);
        int n = tv.length;
        LgTyp[] vt = new LgTyp[n];
        vt[0] = tv[n-1];
        for (int j = 1; j < n; ++j) 
               { vt[j] = tv[j-1]; };
        return vt; 
    };
    public static LgTyp[] getFunFormAux (LgTyp t) {
	if ((t.tCon.nameT.equals (LgTCon.funT.nameT)) 
          && (t.tArgs.length == 2)) 
	  { 
            LgTyp[] tv = getFunFormAux (t.tArgs[1]);
	    LgTyp[] ntv = new LgTyp[tv.length+1];
            ntv[0] = t.tArgs[0];
            for (int j = 0; j < tv.length; ++j) 
		{ ntv[j+1] = tv[j]; };
            return ntv; }
          else { LgTyp[] atv = {t};
          return atv; }
    };
    public static LgTyp buildFunType (int n) {
	LgTyp k = tLogic;
	for (int i = 0; i < n; ++i)
	    { LgTyp[] ks = {tLogic,k};
	      k = new LgTyp (LgTCon.funT, ks); };
	return k;
    };
    public static LgTyp buildFunType (LgTyp[] xs) {
	if (xs.length < 2) return xs[0]; else {
	    LgTyp k = xs[0]; 
	for (int i = 1; i < xs.length; ++i)
	    { LgTyp[] ks = {xs[xs.length - i],k};
	      k = new LgTyp (LgTCon.funT, ks); };
	return k; }
    };
}


class LgTCon implements Serializable 
{
    public String nameT;
    public LgKind kindT;
    public int arityT;
    public String desT;
    public static final LgTCon funT = 
             new LgTCon ("Fun", 2, "CONS");

    LgTCon () {};
    LgTCon (String n) { 
        nameT = n; 
        kindT = new LgKind();
        arityT = 0;
        desT = "CONS";
    };
    LgTCon (String n, String d) {
        nameT = n; 
        kindT = new LgKind();
        arityT = 0; 
        desT = d;
    };
    LgTCon (String n, int x, String d) {
        nameT = n; 
        kindT = new LgKind(x);
        arityT = x; 
        desT = d;
    };
    LgTCon (String n, LgKind k, String d) {
        nameT = n; 
        kindT = k; 
        arityT = kindT.tlK.length;
        desT = d;
    };
    LgTCon (String n, int x) {
        nameT = n; 
        kindT = new LgKind(x);
        arityT = x; 
        desT = "CONS";
    };
    LgTCon (String n, LgKind k) {
        nameT = n; 
        kindT = k; 
        arityT = kindT.tlK.length;
        desT = "CONS";
    };
}


/* ("star") is the kind of a type; 
   ("star" ["star"]) is the kind of a type constructor;
   etc..  */
class LgKind implements Serializable
{
    public int arityK;
    public LgKind[] hdK;
    public LgKind[] tlK;
    public static final String star = "*";
    public static final LgKind starK = 
                     new LgKind ();

    LgKind () { 
        arityK = 0;
        hdK = new LgKind [0]; 
        tlK = new LgKind [0];
    };
    LgKind (LgKind k, int n) { 
        arityK = n;
        hdK = new LgKind [1];
        hdK[0] = k;
        LgKind[] tlK = new LgKind [n];
        for (int i=0; i < n; ++i) {
	    tlK[i] = new LgKind(); };
    };
    LgKind (int n) {
        arityK = n;
        hdK = new LgKind [1];
        hdK[0] = starK;
        LgKind[] tlK = new LgKind [n];
        for (int i=0; i < n; ++i) {
	    tlK[i] = starK; };
    };
    LgKind (LgKind k, LgKind ks[]) {
        arityK = ks.length;
        hdK = new LgKind [1];
        hdK[0] = k;
        tlK = ks;
    };
    LgKind (LgKind ks[]) {
        arityK = ks.length;
        hdK = new LgKind [1];
        hdK[0] = starK;
        tlK = ks;
    };
}

