package fta3;

import java.io.*;
import java.lang.Integer;
import java.util.*;

class RTree {

    public TComp tHead;
    public RTree[] tTail; 

    RTree () {
	tHead = new TComp () {};
        tTail = new RTree[0];
    }
    RTree (TComp x) {
	tHead = x;
        int n = x.cCauses.length;
        tTail = new RTree[n];
        for (int i = 0; i < n; i++) {
            tTail[i] = new RTree ();
	}
    }

    public boolean equals (RTree t) {
        if (tHead.equals (t.tHead) &&
            Arrays.equals (tTail, t.tTail))
	    return true; else return false;  
    }

    // preparation function
    public static RTree[] tcomp2rt (TComp[] cs) {
        int n = cs.length;
        RTree[] rt = new RTree[n];
        SimpleIO.promptln ("");
        SimpleIO.promptln ("Printing the gate list: ");
        SimpleIO.promptln ("");
        for (int i = 0; i < n; i++) {
            rt[i] = new RTree (cs[i]);
        SimpleIO.promptln ("GATE: " + rt[i].tHead.cGate.nName + 
                          ", " + rt[i].tHead.cGate.nId);
	}
        return rt;
    }

    public static RTree buildRT (RTree[] rs) {
        int n = rs.length;
        RTree[] ss = new RTree[n-1];
        SimpleIO.promptln ("");
        SimpleIO.promptln ("Printing the effect list: ");
        SimpleIO.promptln ("");
        for (int i = 0; i < n-1; i++) {
            ss[i] = rs[i+1];
        SimpleIO.promptln ("EFFECT: " + ss[i].tHead.cEffect.nId);
	}
        SimpleIO.promptln ("");
        SimpleIO.promptln ("Printing the leaf list: ");
        SimpleIO.promptln ("");
        return (ct2rt (rs[0], ss));
    }

    // recursive function
    public static RTree ct2rt (RTree t, RTree[] xs) {
        int h = t.tHead.cCauses.length;
        for (int i = 0; i < h; i++) {
            String u =  t.tHead.cCauses[i].nType;
	    if (t.tTail[i].equals (new RTree ())) {
               if (u.equals ("0")) {
		  t.tTail[i] = matchCompRT (t.tHead, i, xs);
	       }
               else {SimpleIO.promptln
                  ("LEAF: " + t.tHead.cCauses[i].nName); continue;}
  	    }
            else {
                   t.tTail[i] = ct2rt (t.tTail[i], xs);
	    }
	}
        return t;
    }

    public static RTree matchCompRT (TComp c, int k, RTree[] xs) {
        String nd = c.cCauses[k].nId;
        int j = xs.length;
        for (int i = 0; i < j; i++) {
            if (nd.equals (xs[i].tHead.cEffect.nId)) {
                return ct2rt (xs[i], xs);}
            else {
                   continue;
                 }
	}
        return (new RTree ());
    }
}





