package fta3;

import java.io.*;
import java.lang.Integer;
import java.util.*;

class TComp {

    public TGate cGate;
    public TNode cEffect;
    public TNode[] cCauses;

    TComp () {
        cGate = new TGate ();
        cEffect = new TNode ();
        cCauses = new TNode[0];
    };
    TComp (TGate g) {
        cGate = g;
        cEffect = new TNode ();
        cCauses = new TNode[0];
    }

    public boolean equals (TComp c) {
        if (cGate.equals (c.cGate) &&
            cEffect.equals (c.cEffect) &&
            Arrays.equals (cCauses, c.cCauses))
	    return true; else return false;
    }

    public static TNode[] ordCauses (TNode[] cs) {
        int n = cs.length;
        if (n == 0) return cs;
        else for (int i = 0; i < n; i++) {
             if (cs[i].nType.equals ("3")) {
                TNode k = cs[i];
                cs[i] = cs[0];
                cs[0] = k;
                break;
	     }
             else continue;
	}
        return cs;
    }

    public String effect () { return (cEffect.nId); }

    public String[] causes () {
        String[] xs = new String[cCauses.length];
        for (int i = 0; i < cCauses.length; i++) {
	  xs[i] = cEffect.nId;
        }  
        return xs;
    }

    public static TComp extTComp (TGate gt, TEdge[] eds) {
	TComp cc = new TComp (gt);
        int x = eds.length;
        for (int i = 0; i < x; i++) {
        if (gt.nId.equals (eds[i].eSource.nId)) {
                  cc.cEffect = eds[i].eDest;
                  break;
            } else continue;
        }
        for (int i = 0; i < x; i++) {
            if (gt.nId.equals (eds[i].eDest.nId)) {
                int k = cc.cCauses.length;
                TNode[] ls = new TNode[k+1];
                for (int j = 0; j < k; j++) {
		    ls[j] = cc.cCauses[j];
		}
                ls[k] = eds[i].eSource;
                cc.cCauses = ordCauses (ls);
	    } 
	}                   
	return cc;	
    }    

    public static TComp extTComp (TEdge e) {
        String nx = "generated:" + e.eSource.nId + "." + e.eDest.nId;
	TGate x = new TGate ("generated", "2", nx, "", "CAND");
        TComp cc = new TComp (x);
        cc.cCauses = new TNode[1];
        cc.cCauses[0] = e.eSource;
        cc.cEffect = e.eDest;
        return cc;
    }

    public static void printTComp (TComp cc) {
	int k = cc.cCauses.length;
        SimpleIO.promptln ("");
	System.out.println ("GATE "); 
        System.out.print ("Id (idt): "); 
	System.out.println (cc.cGate.nId); 
        System.out.print ("Type (gatetype): "); 
	System.out.println (cc.cGate.nType); 
        System.out.print ("Internal Name (nme): "); 
       	System.out.println (cc.cGate.nIName); 
        System.out.print ("Description (nam): "); 
	System.out.println (cc.cGate.nName); 
        System.out.print ("Arity: "); 
	System.out.println (cc.cCauses.length); 
	System.out.println (" "); 
	System.out.print ("EFFECT: "); 
        System.out.print ("Id (idt): "); 
	System.out.println (cc.cEffect.nId); 
        System.out.print ("Name: "); 
	System.out.println (cc.cEffect.nName); 
        System.out.print ("Type: "); 
	System.out.println (cc.cEffect.nType); 
	System.out.println (" "); 
        for (int x = 0; x < k; ++x) {
            int y = x + 1;
   	    System.out.print ("CAUSE " + y + ": "); 
            System.out.print ("Id (idt): "); 
	    System.out.println (cc.cCauses[x].nId); 
            System.out.print ("Name: "); 
	    System.out.println (cc.cCauses[x].nName); 
            System.out.print ("Type: "); 
	    System.out.println (cc.cCauses[x].nType); 
	}
	System.out.println (" "); 
    }
}





